import { SupportedLanguageTypes, themesType } from 'code-block';
import { ComponentPublicInstance, ExtractPropTypes, MaybeRefOrGetter, PropType } from 'vue';
export declare const codeBlockProps: () => {
    readonly class: {
        readonly type: PropType<string>;
        readonly required: false;
        readonly default: "";
    };
    readonly id: {
        readonly type: PropType<string>;
        readonly required: false;
        readonly default: "";
    };
    readonly code: {
        readonly type: PropType<string>;
        readonly required: true;
    };
    readonly language: {
        readonly type: PropType<SupportedLanguageTypes>;
        readonly required: true;
    };
    readonly codeClass: {
        readonly type: PropType<string>;
        readonly required: false;
        readonly default: "";
    };
    readonly linesHighlighted: {
        readonly type: PropType<string[] | number[]>;
        readonly required: false;
        readonly default: readonly [];
    };
    readonly wordsHighlighted: {
        readonly type: PropType<string[]>;
        readonly required: false;
        readonly default: readonly [];
    };
    readonly asElement: {
        readonly type: PropType<string>;
        readonly required: false;
        readonly default: "";
    };
    readonly numbered: {
        readonly type: PropType<boolean>;
        readonly required: false;
        readonly default: false;
    };
    readonly theme: {
        readonly type: PropType<themesType>;
        readonly required: true;
    };
    readonly fileName: {
        readonly type: PropType<string>;
        readonly required: false;
        readonly default: "";
    };
    readonly showHeader: {
        readonly type: PropType<boolean>;
        readonly required: false;
        readonly default: false;
    };
};
export type codeBlockPropsTypes = ExtractPropTypes<ReturnType<typeof codeBlockProps>>;
export type codeBlockExpose = {};
export type codeBlockInstance = ComponentPublicInstance<codeBlockPropsTypes, codeBlockExpose>;
export interface UseCodeBlockProps {
    class: MaybeRefOrGetter<string | null>;
    id: MaybeRefOrGetter<string | null>;
    code: MaybeRefOrGetter<string>;
    language: MaybeRefOrGetter<SupportedLanguageTypes>;
    codeClass: MaybeRefOrGetter<string>;
    linesHighlighted: MaybeRefOrGetter<string[] | number[]>;
    wordsHighlighted: MaybeRefOrGetter<string[]>;
    asElement: MaybeRefOrGetter<string>;
    numbered: MaybeRefOrGetter<boolean>;
    theme: MaybeRefOrGetter<themesType>;
    fileName: MaybeRefOrGetter<string>;
    showHeader: MaybeRefOrGetter<boolean>;
}
export type PublicCodeBlockProps = Partial<Omit<UseCodeBlockProps, 'code' | 'class' | 'id' | 'language' | 'codeClass' | 'linesHighlighted' | 'wordsHighlighted' | 'asElement' | 'numbered' | 'theme' | 'fileName' | 'showHeader'>> & Pick<UseCodeBlockProps, 'code' | 'class' | 'id' | 'language' | 'codeClass' | 'linesHighlighted' | 'wordsHighlighted' | 'asElement' | 'numbered' | 'theme' | 'fileName' | 'showHeader'>;
